<script>
import Vue from 'vue';
import _ from 'lodash';

export default Vue.extend({
  name: 'Careers',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    jobId: {
      // You can find the job ID in the URL of the departments endpoint
      // https://boards-api.greenhouse.io/v1/boards/gitlab/departments/
      type: Number,
      default: 4011044002, // This is the ID for the Engineering job family
      required: false,
    },
  },
  data() {
    return {
      jobsData: [],
    };
  },
  async fetch() {
    const request = await fetch(
      `https://boards-api.greenhouse.io/v1/boards/gitlab/departments/${this.jobId}?render_as=tree`,
    ).then((response) => response.json());

    // The Greenhouse API endpoint doesn't show all jobs in the department head node,
    // but will show all jobs in the children nodes. So we need to get the children nodes
    // and then get the jobs from those nodes.

    const result = [];

    const getTerminatedChildren = (parent) => {
      if (parent.children) {
        parent.children.forEach((child) => {
          if (child.children.length !== 0) {
            getTerminatedChildren(child);
          } else {
            result.push(child);
          }
        });
      }
    };

    getTerminatedChildren(request);

    const departmentsWithOpenings = result.filter(
      (item) => item.jobs.length !== 0,
    );

    let jobList = [];

    departmentsWithOpenings.forEach((job) => {
      jobList = jobList.concat(job.jobs);
    });

    if (jobList.length !== 0) {
      if (jobList.length > 5) {
        this.jobsData = _.sampleSize(jobList, 11);
      } else {
        this.jobsData = jobList;
      }
    } else {
      const allJobs = await fetch(
        'https://boards-api.greenhouse.io/v1/boards/gitlab/jobs',
      ).then((response) => response.json());

      this.jobsData = _.sampleSize(allJobs.jobs, 11);
    }
  },
});
</script>

<template>
  <div class="careers">
    <SlpContainer>
      <SlpRow class="slp-my-96 careers__container" style="gap: 48px">
        <SlpColumn :cols="6" style="flex: initial">
          <SlpTypography
            v-if="data.header"
            variant="heading2-bold"
            tag="h2"
            class="slp-pb-16"
          >
            {{ data.header }}
          </SlpTypography>

          <div
            v-if="data.text"
            class="slp-pb-16 careers__text"
            v-html="$md.render(data.text)"
          ></div>

          <SlpButton
            v-if="data.cta?.text"
            :href="
              data.cta.externalUrl ?? 'https://about.gitlab.com/jobs/all-jobs/'
            "
            :data-ga-name="data.cta.dataGaName"
            :data-ga-location="data.cta.dataGaLocation"
            variant="primary"
            class="slp-mt-32"
            >{{ data.cta.text }}</SlpButton
          >
        </SlpColumn>
        <SlpColumn :cols="6" style="flex: initial">
          <div class="careers__job-posts">
            <a
              v-for="(post, index) in jobsData"
              :key="index"
              :href="post.absolute_url"
              class="slp-flex careers__post slp-pl-8"
              :data-ga-name="`${post.title}, ${post.location.name}`"
              data-ga-location="body"
            >
              <img src="/nuxt-images/icons/events/user.svg" />
              <SlpTypography variant="body2" tag="p" class="slp-py-16 slp-px-8">
                {{ post.title }}, ({{ post.location.name }})
              </SlpTypography>
            </a>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.careers {
  background: #f6f3fe;

  &__container {
    gap: 48px;
    flex-wrap: nowrap;

    @media screen and (max-width: $breakpoint-sm) {
      flex-wrap: wrap;
    }
  }

  &__job-posts {
    background: #fff;
    color: #7759c2;
    border-radius: 0 0 90px 0;
    padding: 56px 24px;
  }

  &__post:hover {
    background: #f6f3fe;
  }
  &__text {
    font-size: 16px;
    font-weight: 400;
    line-height: 20px;
    :deep {
      h3 {
        font-size: 24px;
        font-weight: 600;
        letter-spacing: -0.6px;
        line-height: 32px;
        padding-bottom: 16px;
      }
      p {
        padding-bottom: 16px;
        &:last-of-type {
          padding-bottom: 0;
        }
      }
    }
  }
}
</style>
